/** @file
 * @brief SerializeServiceContainer class implementation. This class contains Service objects in a list for serialization.
 *
 *
 *
 * @copyright Intra2net AG
 * @license GPLv2
*/

#include "serializeservicecontainer.h"

// Following boost macros are needed for serialization of derived classes through a base class pointer (Service *).
BOOST_CLASS_EXPORT_GUID(ServiceOds, "ServiceOds")
BOOST_CLASS_EXPORT_GUID(ServiceDhs, "ServiceDhs")
BOOST_CLASS_EXPORT_GUID(ServiceDyns, "ServiceDyns")
BOOST_CLASS_EXPORT_GUID(ServiceDyndns, "ServiceDyndns")
BOOST_CLASS_EXPORT_GUID(ServiceEasydns, "ServiceEasydns")
BOOST_CLASS_EXPORT_GUID(ServiceTzo, "ServiceTzo")
BOOST_CLASS_EXPORT_GUID(ServiceZoneedit, "ServiceZoneedit")
BOOST_CLASS_EXPORT_GUID(ServiceGnudip, "ServiceGnudip")


SerializeServiceContainer::SerializeServiceContainer()
{
}


SerializeServiceContainer::~SerializeServiceContainer()
{
}

/**
 * Serialize function needed by boost/serialization to define which members should be stored as the object state.
 * In this case the STL list of Service pointers will be serialized.
 * @param ar Archive
 * @param version Version
 */
/*
template<class Archive>
void SerializeServiceContainer::serialize(Archive & ar, const unsigned int version)
{
    ar & ContainingServices;
}
*/

void SerializeServiceContainer::add_service(Service::Ptr service)
{
    ContainingServices.push_back(service);
}


std::list<Service::Ptr> SerializeServiceContainer::get_containing_services() const
{
    return ContainingServices;
}
